<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>AtomicFileOutputStream.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.common</a> &gt; <span class="el_source">AtomicFileOutputStream.java</span></div><h1>AtomicFileOutputStream.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.zookeeper.common;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FilterOutputStream;
import java.io.IOException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/*
 * This code is originally from HDFS, see the similarly named files there
 * in case of bug fixing, history, etc...
 */

/**
 * A FileOutputStream that has the property that it will only show up at its
 * destination once it has been entirely written and flushed to disk. While
 * being written, it will use a .tmp suffix.
 * 
 * When the output stream is closed, it is flushed, fsynced, and will be moved
 * into place, overwriting any file that already exists at that location.
 * 
 * &lt;b&gt;NOTE&lt;/b&gt;: on Windows platforms, it will not atomically replace the target
 * file - instead the target file is deleted before this one is moved into
 * place.
 */
public class AtomicFileOutputStream extends FilterOutputStream {
    private static final String TMP_EXTENSION = &quot;.tmp&quot;;

<span class="fc" id="L49">    private final static Logger LOG = LoggerFactory</span>
<span class="fc" id="L50">            .getLogger(AtomicFileOutputStream.class);</span>

    private final File origFile;
    private final File tmpFile;

    public AtomicFileOutputStream(File f) throws FileNotFoundException {
        // Code unfortunately must be duplicated below since we can't assign
        // anything
        // before calling super
<span class="fc" id="L59">        super(new FileOutputStream(new File(f.getParentFile(), f.getName()</span>
                + TMP_EXTENSION)));
<span class="fc" id="L61">        origFile = f.getAbsoluteFile();</span>
<span class="fc" id="L62">        tmpFile = new File(f.getParentFile(), f.getName() + TMP_EXTENSION)</span>
<span class="fc" id="L63">                .getAbsoluteFile();</span>
<span class="fc" id="L64">    }</span>

    @Override
    public void close() throws IOException {
<span class="fc" id="L68">        boolean triedToClose = false, success = false;</span>
        try {
<span class="fc" id="L70">            flush();</span>
<span class="fc" id="L71">            ((FileOutputStream) out).getChannel().force(true);</span>

<span class="fc" id="L73">            triedToClose = true;</span>
<span class="fc" id="L74">            super.close();</span>
<span class="fc" id="L75">            success = true;</span>
<span class="fc" id="L76">        } finally {</span>
<span class="fc" id="L77">            if (success) {</span>
<span class="pc" id="L78">                boolean renamed = tmpFile.renameTo(origFile);</span>
<span class="pc bpc" id="L79" title="3 of 4 branches missed.">                if (!renamed) {</span>
                    // On windows, renameTo does not replace.
<span class="nc bnc" id="L81" title="All 8 branches missed.">                    if (!origFile.delete() || !tmpFile.renameTo(origFile)) {</span>
<span class="nc" id="L82">                        throw new IOException(</span>
                                &quot;Could not rename temporary file &quot; + tmpFile
                                        + &quot; to &quot; + origFile);
                    }
                }
<span class="pc" id="L87">            } else {</span>
<span class="pc bpc" id="L88" title="3 of 4 branches missed.">                if (!triedToClose) {</span>
                    // If we failed when flushing, try to close it to not leak
                    // an FD
<span class="pc" id="L91">                    IOUtils.closeStream(out);</span>
                }
                // close wasn't successful, try to delete the tmp file
<span class="pc bpc" id="L94" title="3 of 4 branches missed.">                if (!tmpFile.delete()) {</span>
<span class="pc bpc" id="L95" title="1 of 2 branches missed.">                    LOG.warn(&quot;Unable to delete tmp file &quot; + tmpFile);</span>
                }
            }
<span class="fc" id="L98">        }</span>
<span class="pc bpc" id="L99" title="1 of 2 branches missed.">    }</span>

    /**
     * Close the atomic file, but do not &quot;commit&quot; the temporary file on top of
     * the destination. This should be used if there is a failure in writing.
     */
    public void abort() {
        try {
<span class="fc" id="L107">            super.close();</span>
<span class="nc" id="L108">        } catch (IOException ioe) {</span>
<span class="nc" id="L109">            LOG.warn(&quot;Unable to abort file &quot; + tmpFile, ioe);</span>
<span class="fc" id="L110">        }</span>
<span class="pc bpc" id="L111" title="1 of 2 branches missed.">        if (!tmpFile.delete()) {</span>
<span class="nc" id="L112">            LOG.warn(&quot;Unable to delete tmp file during abort &quot; + tmpFile);</span>
        }
<span class="fc" id="L114">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>